#include <Servo.h>
#include "House.h"

#define doorPin 11
#define doorInput 3 //pin 4 on Uno 
#define buzzerPin 12
#define buzzerInput 2 //pin 5 on Uno 
#define pin2Int  0
#define pin3Int  1

volatile int prevDoor, prevBuzzer; //hold previous status of door and buzzer
HouseObject houseDoor(doorPin, doorInput); //instantiate door object
HouseObject houseRadio(buzzerPin, buzzerInput); //instantiate buzzer object

void setup() {
  Serial.begin(9600);
  attachInterrupt(pin3Int, door, CHANGE);
  attachInterrupt(pin2Int, buzzer, CHANGE);
}


void loop() {
     if(prevBuzzer == 1){
       houseRadio.playTune();
       Serial.println("Buzzer On");
       prevBuzzer = 0;
     }
}

void door() {
  if(prevDoor == 0){ //if door was previously closed, open door
    houseRadio.silent();
    houseDoor.openDoor();
    Serial.println("Open door");
    prevDoor = 1;
  }
  else{ //if door was previously open, close door
    houseRadio.silent();
    houseDoor.closeDoor();
    Serial.println("Close door");
    prevDoor = 0;
  }
}



void buzzer() {
  
  if(prevBuzzer == 0){ //if buzzer was previously off, set flag to turn buzzer on in main loop
    prevBuzzer = 1;
  }
  else{ //if buzzer was previously on, turn buzzer off
    houseRadio.silent(); 
    Serial.println("Buzzer Off");
    prevBuzzer = 0;
  }
}
